function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import IconFont from "../../../iconfont";
// import Search from "@/components/Search";
import React from "react";
import { Form } from "antd";
import classNames from "classnames";
import { useMemo, useState } from "react";
import { fieldList, getFieldByType } from "../fields";
import styles from "./index.less";
var SelectFieldCom = function SelectFieldCom(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var currentField = useMemo(function () {
    var _getFieldByType;
    return (_getFieldByType = getFieldByType(value)) === null || _getFieldByType === void 0 ? void 0 : _getFieldByType.field;
  }, [value]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles["field-list"]
  }, open ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: styles["current-field"],
    onClick: function onClick() {
      setOpen(false);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: styles["left"]
  }, /*#__PURE__*/React.createElement(IconFont, {
    className: styles["icon"],
    type: currentField === null || currentField === void 0 ? void 0 : currentField.field_icon
  }), /*#__PURE__*/React.createElement("span", {
    className: styles["name"]
  }, currentField === null || currentField === void 0 ? void 0 : currentField.field_name)), /*#__PURE__*/React.createElement(IconFont, {
    type: "pi-a-Property3caret-down1",
    className: styles["right"]
  }))) : /*#__PURE__*/React.createElement(React.Fragment, null, fieldList.map(function (d) {
    return /*#__PURE__*/React.createElement("div", {
      className: classNames(styles["field-item"], _defineProperty({}, styles["active"], value === d.field_type)),
      key: d.field_type,
      onClick: function onClick() {
        setOpen(true);
        onChange(d.field_type);
      }
    }, /*#__PURE__*/React.createElement(IconFont, {
      type: d.field_icon,
      className: styles["field-icon"]
    }), /*#__PURE__*/React.createElement("div", {
      className: styles["field-name"]
    }, d.field_name));
  })));
};
var FieldEditor = function FieldEditor(_ref2) {
  var _getFieldByType2;
  var fieldType = _ref2.fieldType;
  var Com = (_getFieldByType2 = getFieldByType(fieldType)) === null || _getFieldByType2 === void 0 ? void 0 : _getFieldByType2.Editor;
  return Com ? /*#__PURE__*/React.createElement(Com, null) : /*#__PURE__*/React.createElement("div", null);
};
var SelectField = function SelectField() {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Form.Item, {
    name: "field_type",
    rules: [{
      required: true,
      message: "Please select a field type"
    }]
  }, /*#__PURE__*/React.createElement(SelectFieldCom, null)), /*#__PURE__*/React.createElement(Form.Item, {
    noStyle: true,
    shouldUpdate: function shouldUpdate(prevValues, currentValues) {
      return prevValues.field_type !== currentValues.field_type;
    }
  }, function (_ref3) {
    var getFieldValue = _ref3.getFieldValue;
    var fieldType = getFieldValue("field_type");
    return /*#__PURE__*/React.createElement(FieldEditor, {
      fieldType: fieldType
    });
  }));
};
export default SelectField;